/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.utils;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectHelper;

import java.io.File;

/**
 * 
 */
public class AntBuildInvoker {
    private File buildFile;

    public AntBuildInvoker(File buildFile) {
        this.buildFile = buildFile;
    }

    public void invokeDefaultTarget() throws AntBuildException {
        try {
            AntUtil.main(new String[]{"-buildfile", buildFile.getAbsolutePath(), "-quiet"});
        } catch (Exception e) {
            throw new AntBuildException(e);
        }

    }

    public void invokeTarget(String target) throws AntBuildException {
        try {
            AntUtil.main(new String[]{"-buildfile", buildFile.getAbsolutePath(), "-quiet", target});
        } catch (Exception e) {
            throw new AntBuildException(e);
        }
    }
}
