/*
 * Copyright 2001-2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.xkms2;

import java.security.Key;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.xml.security.encryption.EncryptedData;
import org.w3c.dom.Element;
import org.wso2.xkms2.util.XKMSUtil;

public class PrivateKey implements XKMSElement, ElementSerializable {

    private Element encryptedData;
    
    private Key privateKey;
    

    public Element getEncryptedData() {
        return encryptedData;
    }

    public void setEncryptedData(Element encryptedData) {
        this.encryptedData = encryptedData;
    }
    
    public void setPrivateKey(Key privateKey) {
        this.privateKey = privateKey;        
    }
    
    public Key getPrivateKey() {
        return privateKey;
    }
    
    public OMElement serialize(OMFactory factory) throws XKMSException {
        OMElement privateKeyElement = factory
                .createOMElement(XKMS2Constants.Q_ELEM_PRIVATE_KEY);
        
        if (encryptedData == null) {
            throw new XKMSException("EncryptedData element is null");
        }
        XKMSUtil.appendChild(encryptedData, privateKeyElement);
        
        return privateKeyElement;
    }
}
