/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.xkms2.core;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ConfigurationContext;
import org.w3c.dom.Document;
import org.wso2.xkms2.XKMSElement;
import org.wso2.xkms2.XKMSException;

/**
 *
 */

public interface XKMSServiceExecutor {


    /**
     *
     * @param xkmsElement
     * @param factory
     * @param document
     * @param protocolExchange
     * @return
     * @throws XKMSException
     * @throws AxisFault
     */
    public OMElement execute(XKMSElement xkmsElement, OMFactory factory, Document document,
                             ProtocolExchange protocolExchange)
            throws XKMSException, AxisFault;

    /**
     * Intialize the service
     *
     * @param configCtx
     * @throws AxisFault
     */
    public void init(ConfigurationContext configCtx) throws AxisFault;


    /**
     * This will return the associated element type
     * @return String
     */
    public String getAssociatedElemenType();


}
