/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.xkms2.service;

import org.wso2.xkms2.KeyBinding;
import org.wso2.xkms2.QueryKeyBinding;
import org.wso2.xkms2.RespondWith;
import org.w3c.dom.Document;
/*
 * 
 */

public interface ValidateService {

    /**
     * The Validate service allows the client to query the binding between a <ds:Keyinfo> element
     * and other data such as an identifier. The client supplies a prototype for the key binding
     * requested. The prototype may specify either a <ds:Keyinfo> element or one or more
     * <UseKeyWith> elements or  both. If the validate request is successful the server returns
     * one or more <KeyBinding> elements that meet the criteria specified in the request.
     *
     * @param queryKeyBinding
     * @param respondWiths
     * @param document
     * @return KeyBinding array
     */
    public KeyBinding[] validate(QueryKeyBinding queryKeyBinding,
                                 RespondWith[] respondWiths,
                                 Document document);
}
