/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.xkms2.p2p;

import org.wso2.xkms2.KeyUsage;
import org.wso2.xkms2.RespondWith;
import org.wso2.xkms2.UseKeyWith;
import org.wso2.xkms2.client.XKMSStub;

import java.util.List;
/*
 * 
 */

public class LocateServiceTest extends AbstractTestCase {


    public void testLocateService0() throws Exception {

        XKMSStub stub = new XKMSStub(null, epr);
        UseKeyWith[] useKeyWiths = new UseKeyWith[]{
                new UseKeyWith(UseKeyWith.PGP, "bob@example.com"),
                new UseKeyWith(UseKeyWith.S_MIME, "bob@example.com")};
        RespondWith[] respondWiths = new RespondWith[] {RespondWith.KEY_NAME,RespondWith.KEY_VALUE};
        KeyUsage[] keyUsages = new KeyUsage[] {KeyUsage.ENCRYPTION};
        stub._getServiceClient().getOptions().setTimeOutInMilliSeconds(1000000);
        List list = stub.locate(useKeyWiths, respondWiths, keyUsages);

        assertTrue(list.size() == 0);
    }

    public void testLocateService1() throws Exception {
        XKMSStub stub = new XKMSStub(null, epr);
        RespondWith[] respondWiths = new RespondWith[] {RespondWith.KEY_NAME,RespondWith.KEY_VALUE};
        KeyUsage[] keyUsages = new KeyUsage[] {KeyUsage.SIGNATURE};
        stub._getServiceClient().getOptions().setTimeOutInMilliSeconds(1000000);

        List list = stub.locate(getCertificate(),respondWiths,keyUsages);

        assertTrue(list.size() == 0);

    }
}
