<!--
  ~ Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" />

    <xsl:template match="ns1:getStatusResponse" xmlns:ns1="http://org.apache.axis2/xsd">

        <h2>@server_name@ Home</h2>
        <p>
            Welcome to the @server_name@ Management Console.
        </p>
        <div id="formset">
            <table class="styledLeft">
            <thead><tr><th colspan="2">System Summary</th></tr></thead>
            <xsl:for-each select="return">
                <tr>
                <td><strong>Server Name</strong></td>
                <td><xsl:value-of select="serverName"/></td>
                </tr>
                <tr>
                <td><strong>Server Version</strong></td>
                <td><xsl:value-of select="wso2wsasVersion"/></td>
                </tr>
                <tr>
                <td><strong>Server Start Time</strong></td>
                <td><xsl:value-of select="serverStartTime"/></td>
                </tr>
                <tr>
                <td><strong>System Up Time</strong></td>
                <td><xsl:value-of select="systemUpTime"/></td>
                </tr>
                <tr>
                <td><strong>Memory Allocated</strong></td>
                <td><xsl:value-of select="totalMemory/value"/><xsl:value-of select="totalMemory/unit"/></td>
                </tr>
                <tr>
                <td><strong>Memory Usage</strong></td>
                <td><xsl:value-of select="usedMemory/value"/><xsl:value-of select="usedMemory/unit"/></td>
                </tr>
                <thead><tr><th colspan="2">Service Summary</th></tr></thead>
                <tr>
                <td><strong>Total Request Count</strong></td>
                <td><xsl:value-of select="requestCount"/></td>
                </tr>
                <tr>
                <td><strong>Total Response Count</strong></td>
                <td><xsl:value-of select="responseCount"/></td>
                </tr>
                <tr>
                <td><strong>Total Fault Count</strong></td>
                <td><xsl:value-of select="faultCount"/></td>
                </tr>
                <tr>
                <td><strong>Active Services</strong></td>
                <td><xsl:value-of select="services"/></td>
                </tr>
            </xsl:for-each>
            </table>
        </div>
    </xsl:template>
</xsl:stylesheet>
